View Issue Details

IDProjectCategoryView StatusLast Update
0000571Pgpool-IIBugpublic2020-02-12 10:23
ReporternglpAssigned Topengbo 
PrioritynormalSeverityminorReproducibilitysometimes
Status resolvedResolutionopen 
PlatformLinuxOSRedHatOS Version7.6
Product Version4.0.7 
Target VersionFixed in Version 
Summary0000571: child process segfault after reload
DescriptionHi,

After a service reload, some child processes ends with segfault

< Dec 30 13:02:30 node pgpool[9312]: [15-1] 2019-12-30 13:02:30: pid 9312: LOG: reload config files.
< Dec 30 13:02:30 node pgpool[9522]: [27-1] 2019-12-30 13:02:30: pid 9522: LOG: reloading config file
< Dec 30 13:02:30 node pgpool[9521]: [18-1] 2019-12-30 13:02:30: pid 9521: LOG: reloading config file
< Dec 30 13:02:30 node pgpool[9524]: [11-1] 2019-12-30 13:02:30: pid 9524: LOG: reloading config file
< Dec 30 13:02:30 node pgpool[9523]: [11-1] 2019-12-30 13:02:30: pid 9523: LOG: reloading config file
< Dec 30 13:02:30 node pgpool[9312]: [16-1] 2019-12-30 13:02:30: pid 9312: WARNING: child process with pid: 9524 was terminated by segmentation fault
< Dec 30 13:02:30 node pgpool[9312]: [17-1] 2019-12-30 13:02:30: pid 9312: LOG: child process with pid: 9524 exited with success and will not be restarted
< Dec 30 13:02:30 node pgpool[9312]: [18-1] 2019-12-30 13:02:30: pid 9312: WARNING: child process with pid: 9522 was terminated by segmentation fault
< Dec 30 13:02:30 node pgpool[9312]: [19-1] 2019-12-30 13:02:30: pid 9312: LOG: child process with pid: 9522 exited with success and will not be restarted
< Dec 30 13:02:30 node pgpool[9312]: [20-1] 2019-12-30 13:02:30: pid 9312: WARNING: child process with pid: 9523 was terminated by segmentation fault
< Dec 30 13:02:30 node pgpool[9312]: [21-1] 2019-12-30 13:02:30: pid 9312: LOG: child process with pid: 9523 exited with success and will not be restarted

Im not sure it occurs always, we've this on prod environment and happened on all nodes that day after reload, but i can setup an environment to make tests if necessary

Attached config

Thanks, Guille
Steps To Reproduce* Add new user entry to pool_passwd (not sure its necessary)
* Reload service with: systemctl reload pgpool
TagsNo tags attached.

Activities

nglp

2020-01-02 23:40

reporter  

pgpool.conf (4,479 bytes)

pengbo

2020-01-08 14:40

developer   ~0003048

You may hit a bug which is fixed in https://www.pgpool.net/mantisbt/view.php?id=565.

Which version of PostgreSQL do you use?

nglp

2020-01-08 17:00

reporter   ~0003049

We are running PostgreSQL 11.5, but doesnt look to be related to postgresql

Childs ending with segfault are launched by reload config process

pengbo

2020-01-20 10:45

developer   ~0003075

It seems a bug of Pgpool-II when health_check_database = ''.
To avoid this bug, you need to set health_check_database = 'postgres'.

nglp

2020-01-21 01:33

reporter   ~0003077

hi pengbo,

i tried without it and adding it, segfault occurs in both modes

thanks, Guille

pengbo

2020-01-21 09:50

developer   ~0003078

Please try to reload more than once.

nglp

2020-01-21 17:20

reporter   ~0003079

yes, you're right, thank you for your help

pengbo

2020-02-12 10:22

developer   ~0003181

This bug is fixed.
https://git.postgresql.org/gitweb/?p=pgpool2.git;a=commit;h=21d620df10fc5627ef7ecffaa1a2eabba711e29e

Issue History

Date Modified Username Field Change
2020-01-02 23:40 nglp New Issue
2020-01-02 23:40 nglp File Added: pgpool.conf
2020-01-06 08:57 pengbo Assigned To => pengbo
2020-01-06 08:57 pengbo Status new => assigned
2020-01-08 14:40 pengbo Note Added: 0003048
2020-01-08 14:40 pengbo Status assigned => feedback
2020-01-08 17:00 nglp Note Added: 0003049
2020-01-08 17:00 nglp Status feedback => assigned
2020-01-20 10:45 pengbo Note Added: 0003075
2020-01-21 01:33 nglp Note Added: 0003077
2020-01-21 09:50 pengbo Note Added: 0003078
2020-01-21 17:20 nglp Note Added: 0003079
2020-02-12 10:18 pengbo Status assigned => resolved
2020-02-12 10:22 administrator Status resolved => assigned
2020-02-12 10:22 pengbo Note Added: 0003181
2020-02-12 10:23 pengbo Status assigned => resolved